package service

import (
	"context"
	"github.com/spf13/cast"
	"gomicro-base/api/member"
	"gomicro-base/api/wallet"
	"gomicro-base/common/logz"
	"gomicro-base/service/wallet/client"
	"gomicro-base/service/wallet/internal/conf"
	"gomicro-base/service/wallet/internal/dao"
	"gomicro-base/service/wallet/internal/model"
)

// WalletService 服务层处理逻辑
type WalletService struct {
	dao *dao.Dao
}

func New(d *dao.Dao) *WalletService {
	return &WalletService{
		dao: d,
	}
}

func (s *WalletService) GetWallet(ctx context.Context, req *wallet.WalletReq) (*model.User, error) {
	getClient := client.GetClient()
	service := member.NewMemberService(conf.Conf.Client.MemberName, getClient)
	info, err := service.GetMemberInfo(ctx, &member.MemberInfoReq{
		UserId: 100027,
		Token:  "WErvu0OLJZ3Mq6dTw8HhQ4bnNsReIoFK",
	})
	if err != nil {
		return nil, err
	}

	logz.Println(info)

	user, err := s.dao.GetUserById(cast.ToInt(req.Id), []string{"*"})
	if err != nil {
		return nil, err
	}
	return user, err
}

func (s *WalletService) ListWallet(ctx context.Context, req *wallet.ListWalletReq) ([]*model.User, error) {
	list, err := s.dao.ListUserGtId(cast.ToInt(req.Id), int(req.Limit))
	if err != nil {
		return nil, err
	}
	return list, nil
}
